import es
import playerlib
import os

oldvals = {}
classlist = {}
indexlist = {}
useridlist = {}
steamidlist = {}

def player_disconnect(ev):
	userid = int(ev['userid'])
	if userid in oldvals:
		del oldvals[userid]
	if userid in useridlist:
		del useridlist[userid]
		
def player_activate(ev):
	userid = int(ev['userid'])
	steamid = ev['es_steamid']
	if steamid in steamidlist:
		adduserid(userid,steamidlist[steamid]['weapon'],steamidlist[steamid]['world'],steamidlist[steamid]['view'])

def checkmodelstring(model):
	if model.startswith('models/'):
		model = model[7:]
	if not model.endswith('.mdl'):
		model += '.mdl'
	return model

def setWorldModel(entity, model):	
	model = checkmodelstring(model)
	index = es.precachemodel('models/%s' % model)
	assert index > 0, ('Unable to precache model, possible invalid model path:  models/%s' % model)
	es.setindexprop(entity, 'CBaseCombatWeapon.m_iWorldModelIndex', index)
	es.setindexprop(entity, 'CBaseEntity.m_clrRender', -1)

def setActiveViewModel(userid, model):
	model = checkmodelstring(model)
	index = es.precachemodel('models/%s' % model)
	assert index > 0, ('Unable to precache model, possible invalid model path:  models/%s' % model)
	viewModelEnt = 'predicted_viewmodel'
	gamename = str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/').rpartition('/')[2].lower()
	if gamename == 'tf':
		viewModelEnt = 'tf_viewmodel'
	viewModelIndex = getActiveViewModelIndex(userid,viewModelEnt)
	assert viewModelIndex > 0, 'Unable to get viewmodel index'
	es.setindexprop(viewModelIndex, 'CBaseViewModel.m_nModelIndex', index)

def getActiveViewModelIndex(userid,viewModelEntity):
	playerHandle = es.getplayerhandle(userid)
	entityList = es.createentitylist(viewModelEntity)
	for index in entityList:
		if es.getindexprop(index, 'CBaseViewModel.m_hOwner') != playerHandle:
			continue
		if es.getplayerprop(userid, 'CBaseCombatCharacter.m_hActiveWeapon') != es.getindexprop(index, 'CBaseViewModel.m_hWeapon'):
			continue
		return index
	return -1

def load():
	if es.exists('command','cm_addclass') == 0:
		es.regcmd('cm_addclass', 'wepmodelchanger/addclasshandler', 'This adds a class')
	if es.exists('command','cm_addindex') == 0:
		es.regcmd('cm_addindex', 'wepmodelchanger/addindexhandler', 'This adds an index')
	if es.exists('command','cm_adduserid') == 0:
		es.regcmd('cm_adduserid', 'wepmodelchanger/adduseridhandler', 'This adds a userid')
	if es.exists('command','cm_addsteamid') == 0:
		es.regcmd('cm_addsteamid', 'wepmodelchanger/addsteamidhandler', 'This adds a steamid')
	if es.exists('command','cm_delclass') == 0:
		es.regcmd('cm_delclass', 'wepmodelchanger/delclasshandler', 'This removes a class')
	if es.exists('command','cm_delindex') == 0:
		es.regcmd('cm_delindex', 'wepmodelchanger/delindexhandler', 'This removes an index')
	if es.exists('command','cm_deluserid') == 0:
		es.regcmd('cm_deluserid', 'wepmodelchanger/deluseridhandler', 'This removes a userid')
	if es.exists('command','cm_delsteamid') == 0:
		es.regcmd('cm_delsteamid', 'wepmodelchanger/delsteamidhandler', 'This removes a steamid')
	download()
	es.addons.registerTickListener(ticker)

def unload():
	es.addons.unregisterTickListener(ticker)

def addclasshandler():
	if es.getargc > 3:
		classname = es.getargv(1)
		worldmodel = es.getargv(2)
		viewmodel = es.getargv(3)
		addclass(classname,worldmodel,viewmodel)
	else:
		es.dbgmsg(0, "Syntax: cm_addclass <classname> <worldmodel> <viewmodel>")

def addindexhandler():
	if es.getargc > 3:
		index = int(es.getargv(1))
		worldmodel = es.getargv(2)
		viewmodel = es.getargv(3)
		addindex(index,worldmodel,viewmodel)
	else:
		es.dbgmsg(0, "Syntax: cm_addindex <index> <worldmodel> <viewmodel>")

def adduseridhandler():
	if es.getargc > 4:
		userid = int(es.getargv(1))
		classname = es.getargv(2)
		worldmodel = es.getargv(3)
		viewmodel = es.getargv(4)
		adduserid(userid,classname,worldmodel,viewmodel)
	else:
		es.dbgmsg(0, "Syntax: cm_adduserid <userid> <class> <worldmodel> <viewmodel>")
		
def addsteamidhandler():
	if es.getargc > 4:
		steamid = es.getargv(1)
		classname = es.getargv(2)
		worldmodel = es.getargv(3)
		viewmodel = es.getargv(4)
		addsteamid(steamid,classname,worldmodel,viewmodel)
	else:
		es.dbgmsg(0, "Syntax: cm_addsteamid <steamid> <class> <worldmodel> <viewmodel>")

def delclasshandler():
	if es.getargc > 1:
		classname = es.getargv(1)
		delclass(classname)
	else:
		es.dbgmsg(0, "Syntax: cm_delclass <classname>")
		
def delindexhandler():
	if es.getargc > 1:
		index = int(es.getargv(1))
		delindex(index)
	else:
		es.dbgmsg(0, "Syntax: cm_delindex <index>")
		
def deluseridhandler():
	if es.getargc > 1:
		userid = int(es.getargv(1))
		deluserid(userid)
	else:
		es.dbgmsg(0, "Syntax: cm_deluserid <userid>")
		
def delsteamidhandler():
	if es.getargc > 1:
		steamid = es.getargv(1)
		delsteamid(steamid)
	else:
		es.dbgmsg(0, "Syntax: cm_delsteamid <steamid>")

def addclass(classname,worldmodel,viewmodel):
	if not classname in classlist:
		classlist[classname] = {}
		classlist[classname]["world"] = worldmodel
		classlist[classname]["view"] = viewmodel
		entlist = es.createentitylist(classname)
		for index in entlist:
			setWorldModel(index,worldmodel)
		userlist = es.getUseridList()
		for userid in userlist:
			if not isdead(userid):
				tclassname = getactiveweaponname(userid)
				if tclassname == classname:
					setActiveViewModel(userid,viewmodel)
	else:
		es.dbgmsg(0, "Specified class already exists. Cannot add.")
	
def addindex(index,worldmodel,viewmodel):
	if not index in indexlist:
		indexlist[index] = {}
		indexlist[index]["world"] = worldmodel
		indexlist[index]["view"] = viewmodel
		setWorldModel(index,worldmodel)
		userlist = es.getUseridList()
		for userid in userlist:
			if not isdead(userid):
				classname = getactiveweaponname(userid)
				newwepindex = getweaponindex(userid,classname)
				if newwepindex == index:
					setActiveViewModel(userid,viewmodel)
	else:
		es.dbgmsg(0, "Specified index already exists. Cannot add.")

def adduserid(userid,classname,worldmodel,viewmodel):
	if not userid in useridlist:
		useridlist[userid] = {}
		useridlist[userid]["weapon"] = classname
		useridlist[userid]["world"] = worldmodel
		useridlist[userid]["view"] = viewmodel
		if not isdead(userid):
			tclassname = getactiveweaponname(userid)
			if tclassname == classname:
				setActiveViewModel(userid,viewmodel)
				index = getweaponindex(userid,classname)
				setWorldModel(index,worldmodel)
	else:
		es.dbgmsg(0, "Specified userid already exists. Cannot add.")
	
def addsteamid(steamid,classname,worldmodel,viewmodel):
	if not steamid in steamidlist:
		steamidlist[steamid] = {}
		steamidlist[steamid]["weapon"] = classname
		steamidlist[steamid]["world"] = worldmodel
		steamidlist[steamid]["view"] = viewmodel
		userid = int(es.getuserid(steamid))
		if userid > 0:
			adduserid(userid,classname,worldmodel,viewmodel)
	else:
		es.dbgmsg(0, "Specified steamid already exists. Cannot add.")
		
def delclass(classname):
	if classname in classlist:
		del classlist[classname]
	else:
		es.dbgmsg(0, "Specified class does not exist. Cannot delete.")
		
def delindex(index):
	if index in indexlist:
		del indexlist[index]
	else:
		es.dbgmsg(0, "Specified index does not exist. Cannot delete.")
		
def deluserid(userid):
	if userid in useridlist:
		del useridlist[userid]
	else:
		es.dbgmsg(0, "Specified userid does not exist. Cannot delete.")
		
def delsteamid(steamid):
	if steamid in steamidlist:
		del steamidlist[steamid]
		userid = int(es.getuserid(steamid))
		if userid in useridlist:
			del useridlist[userid]
	else:
		es.dbgmsg(0, "Specified steamid does not exist. Cannot delete.")

def ticker():
	useridlist = es.getUseridList()
	for userid in useridlist:
		checkweapon(userid)

def checkweapon(userid):
	global oldvals
	if userid not in oldvals:
		oldvals[userid] = {}
		oldvals[userid]["windex"] = -1
		oldvals[userid]["whandle"] = -1
		oldvals[userid]["wname"] = ""
	oldweapon = oldvals[userid]["whandle"]
	newweapon = es.getplayerprop(userid, 'CBaseCombatCharacter.m_hActiveWeapon')
	if newweapon != oldweapon:
		if not isdead(userid):
			classname = getactiveweaponname(userid)
			newwepindex = getweaponindex(userid,classname)
			oldindex = oldvals[userid]["windex"]
			oldclassname = oldvals[userid]["wname"]
			weapon_changed(userid,oldindex,newwepindex,oldclassname,classname)
			oldvals[userid]["whandle"] = newweapon
			oldvals[userid]["windex"] = newwepindex
			oldvals[userid]["wname"] = classname

def weapon_changed(userid,oldindex,newindex,oldclass,newclass):
	if newclass in classlist:
		setActiveViewModel(userid, classlist[newclass]["view"])
		setWorldModel(newindex, classlist[newclass]["world"])
	elif newindex in indexlist:
		setActiveViewModel(userid, indexlist[newindex]["view"])
		setWorldModel(newindex, indexlist[newindex]["world"])
	elif userid in useridlist:
		if useridlist[userid]['weapon'] == newclass:
			setActiveViewModel(userid, useridlist[userid]["view"])
			setWorldModel(newindex, useridlist[userid]["world"])
	if oldclass in classlist:
		setWorldModel(oldindex, classlist[oldclass]["world"])
	elif oldindex in indexlist:
		setWorldModel(oldindex, indexlist[oldindex]["world"])

def es_map_changed(ev):
	download()		

def getactiveweaponname(userid):
	plist = es.createplayerlist(userid)
	return plist[userid]['weapon']
		
def getweaponindex(userid,weapon):
	myPlayer = playerlib.getPlayer(userid)
	return myPlayer.get('weaponindex',weapon)
	
def isdead(userid):
	plist = es.createplayerlist(userid)
	if (plist[userid]['isdead'] == 0):
		return False
	return True

def download():
	f = open('%s/downloads.txt'%(es.getAddonPath('wepmodelchanger')), 'rb')
	for line in f.readlines():
		es.server.queuecmd('downloadable %s'%(line))
	f.close()